<template>
  <div page="wallet">
    <div class="wallet-grid">
      <div>
        <div class="label">ULUS {{ $t('to_send') }}</div>
        <el-input
          border
          v-model="form.amount"
          v-mask="{
            alias: 'numeric',
            groupSeparator: ',',
            autoGroup: true,
            digits: 2,
            allowMinus: false
          }"
        >
          <svg-icon name="ULUS" width="24" height="24" slot="prefix" />
        </el-input>
      </div>
      <div>
        <div class="label">{{ $t('to_account') }}</div>
        <Autocomplete
          border
          class="inline-input"
          v-model="form.users"
          :fetch-suggestions="querySearch"
          :trigger-on-focus="false"
        >
          <template slot="prefix"> @ </template>
        </Autocomplete>
      </div>
      <div>
        <Button
          variant="none"
          border="primary"
          size="small"
          class="btn-space"
          @click="modals.purchase = !modals.purchase"
        >
          Send
          <svg-icon name="arrow-line" class="icon-radius" />
        </Button>
      </div>
    </div>

    <Transactions :where="{}" />

    <portal to="modal">
      <Modal v-model="modals.purchase">
        <template slot="title">Purchase</template>
        <template slot="description">ULUS to btc</template>
        <template slot="info">
          Note: approval time after send 72 hours max
        </template>
        <div class="modal__input">
          <el-input
            border
            line
            v-model="form.btc"
            placeholder="BTC wallet address"
          />
        </div>
        <div class="modal__input">
          <el-input
            border
            line
            v-model="form.amount"
            placeholder="ULUS amount"
          />
        </div>
        <Button size="small" @click="modals.purchase = !modals.purchase">
          Create contract
          <svg-icon name="arrow-line" class="icon-radius" />
        </Button>
      </Modal>
    </portal>
  </div>
</template>

<script lang="ts">
import { defineComponent, ref, reactive } from '@nuxtjs/composition-api'
import Modal from '@/components/ui/Modal.vue'

import elInput from '@/components/element/Input.vue'
import Autocomplete from '@/components/element/Autocomplete.vue'
import Button from '@/components/ui/Button.vue'

import Transactions from '@/components/profile/wallet/Transactions.vue'

export default defineComponent({
  name: 'WalletSendPage',
  components: { Modal, Transactions, elInput, Autocomplete, Button },
  setup() {
    const modals = ref({
      purchase: false
    })

    const user_list = [
      { value: 'vue' },
      { value: 'element' },
      { value: 'cooking' },
      { value: 'mint-ui' },
      { value: 'vuex' },
      { value: 'vue-router' },
      { value: 'babel' }
    ]
    const form = reactive({
      amount: '',
      btc: '',
      users: ''
    })

    const querySearch = (queryString: any, cb: any) => {
      const links = user_list
      const results = queryString
        ? links.filter(createFilter(queryString))
        : links
      // call callback function to return suggestions
      cb(results)
    }
    const createFilter = (queryString: any) => {
      return (link: any) => {
        return link.value.toLowerCase().indexOf(queryString.toLowerCase()) === 0
      }
    }

    return {
      modals,
      form,
      querySearch,
      createFilter
    }
  }
})
</script>

<style lang="scss" scoped>
.wallet-grid {
  display: grid;
  grid-template-columns: 1fr;
  grid-gap: 30px 24px;
  align-items: flex-end;
  margin-bottom: 30px;

  @media (min-width: 1199.98px) {
    grid-template-columns: 1fr 1fr 1fr;
    margin-bottom: 70px;
  }

  .label {
    font-weight: bold;
    font-size: 18px;
    line-height: 23px;
    letter-spacing: 0.9px;
    color: #8591ad;
    text-transform: uppercase;
    margin-bottom: 20px;
    display: flex;
    align-items: center;

    svg {
      margin-left: 12px;
    }
  }
}
</style>
